   (DEFUN CONNLISTS (LAMBDA (GRAPH)
   ; ஥ ᯨ᪠ ᯨ᪮ 設  吝
   ; GRAPH    - , ।⠢ ன ᬥ 
   ;             樠⨢ ᯨ᪠
      (CONNLSTS GRAPH NIL)
   ))
   ; -----------------------------------
   (DEFUN CONNLSTS (LAMBDA (GRAPH LISTS)
      (COND ( (NULL GRAPH) LISTS )
            ( T (COND ( (NULL (LMEMBER (CAAR GRAPH) LISTS))
                           (CONNLSTS
                               (CDR GRAPH)
                               (CONS (DEPTHFIRST GRAPH (CAAR GRAPH))
                                     LISTS)) )
                      (  T  (CONNLSTS (CDR GRAPH) LISTS) )) )
      )
   ))
   ; -----------------------------------
   (DEFUN LMEMBER (LAMBDA (VERTEX LISTS)
   ; 㭪 ஢, ᮤন  設 VERTEX  
   ;    -  ᯨ᪮, ⠢ LISTS
      (AND LISTS
           (OR (MEMBER  VERTEX (CAR LISTS))
               (LMEMBER VERTEX (CDR LISTS))))
   ))
   ; ------------------------------------
   (DEFUN DEPTHFIRST (LAMBDA (GRAPH ROOT)
   ; 室   㡨:
   ; GRAPH - , ।⠢ ன ᬥ 
   ;          樠⨢ ᯨ᪠,
   ; ROOT  - 設,  ன 稭 室 ,
   ; : ᯨ᮪ 設   浪 饭  㡨
      (COND ( (NULL GRAPH) NIL )
            (  T  (DEFI GRAPH (LIST ROOT) (LIST ROOT)) ))
   ))
   ; --------------------------------------
   (DEFUN DEFI (LAMBDA (GRAPH VISITED PATH)
   ; GRAPH   - , ।⠢ ன ᬥ 
   ;            樠⨢ ᯨ᪠,
   ; VISITED - ᯨ᮪ 㦥 饭 設,
   ; PATH    - ᯨ᮪ 設, ।騩  饭
      (COND ( (NULL PATH) (REVERSE VISITED) )
            ( T  (COND ( (NULL (EXPND GRAPH VISITED (CAR PATH)))
                            (DEFI GRAPH VISITED (CDR PATH)) )
                       (  T  (DEFI GRAPH
                                   (CONS (EXPND GRAPH VISITED (CAR PATH))
                                         VISITED)
                                   (CONS (EXPND GRAPH VISITED (CAR PATH))
                                         PATH)) )) )
      )
   ))
   ; -----------------------------------------
   (DEFUN EXPND (LAMBDA (GRAPH VISITED VERTEX)
   ; 롮   GRAPH ᫥饩   ᬮ७
   ;        設, ᬥ  設 VERTEX
      (COND ( (NULL (NEIGHBOUR3 VERTEX GRAPH)) NIL )
            (  T  (FIRSTNOTVISITED VISITED (NEIGHBOUR3 VERTEX GRAPH)) )
      )
   ))
   ; --------------------------------------------
   (DEFUN FIRSTNOTVISITED (LAMBDA (VISITED VLIST)
   ;  ࢮ 饭 設  ᯨ᪥ VLIST
   ; VISITED - ᯨ᮪ 㦥 饭 設
      (COND ( (NULL VLIST) NIL )
            (  T  (COND ( (NULL (MEMBER (CAR VLIST) VISITED))
                             (CAR VLIST) )
                        (  T  (FIRSTNOTVISITED VISITED (CDR VLIST)) )) )
      )
   ))
   ; ---------------------------------
   (DEFUN NEIGHBOUR3 (LAMBDA (X GRAPH)
   ; 㭪 頥 ᯨ᮪ 設  GRAPH, ᬥ 
   ;                 設 X
      (COND ( (NULL (ASSOC X GRAPH)) NIL )
            (  T  (CDR (ASSOC X GRAPH)) ))
   ))
   (RDS)
